#ifndef __TABELLAHASHABASE__
#define __TABELLAHASHBASE__

#include "TabellaHashBase.h"
#include <list>

using namespace std;

template <class Elem> class TabellaHash: public TabellaHashBase<Elem> 
{
private:
        list<Elem> *dati;
        list<int> *keys;
        int dim;
public:
       TabellaHash(int dim);
       virtual ~TabellaHash();
       virtual bool insert(Elem e, int key);
	   virtual bool search(Elem &e, int key);
	   virtual bool del(int key);
};

template <class Elem> 
TabellaHash<Elem>::TabellaHash(int dim)
{
    this->dim = dim;
    dati = new list<Elem>[dim];
    keys = new list<int>[dim];
}
template <class Elem> 
TabellaHash<Elem>::~TabellaHash()
{
    delete[] dati;
    delete[] keys;
}
template <class Elem> 
bool             
TabellaHash<Elem>::insert(Elem e, int key)
{
   int pos=key%dim;
   dati[pos].push_front(e);
   keys[pos].push_front(key);
   return true;
}
template <class Elem> 
bool             
TabellaHash<Elem>::search(Elem &e, int key)
{
   bool found=false;
   int pos=key%dim;
   list<int>::iterator i;
   typename list<Elem>::iterator j = dati[pos].begin();
   for (i = keys[pos].begin(); i!=keys[pos].end(); i++)
   {
       if (*i==key)
       {
          found = true;
          e=*j;
          break;
       }
       j++;         
   }
   return found;
}
template <class Elem> 
bool                          
TabellaHash<Elem>::del(int key)
{
   bool found=false;
   int pos=key%dim;
   list<int>::iterator i;
   typename list<Elem>::iterator j = dati[pos].begin();
   for (i = keys[pos].begin(); i!=keys[pos].end(); i++)
   {
       if (*i==key)
       {
          found = true;
          dati[pos].erase(i);
          keys[pos].erase(j);
          break;
       }
       j++;         
   }
   return found;    
}
#endif
