#ifndef __TABELLAHASH2__
#define __TABELLAHASH2__

#include <vector>

#include "TabellaHashBase.h"
#include "HashElem.h"
#include "HashFunctionBase.h"
#include "ProbeFunctionBase.h"

using namespace std;

template <class Elem> class TabellaHash2: public TabellaHashBase<Elem> 
{
private:
        HashElem<Elem> *dati;
        HashFunctionBase *hashFun;
        ProbeFunctionBase *probeFun;
        int dim;
public:
       TabellaHash2(int dim, HashFunctionBase *h, ProbeFunctionBase *p);
       virtual ~TabellaHash2();
       virtual bool insert(Elem e, int key);
	   virtual bool search(Elem &e, int key);
	   virtual bool del(int key);
};

template <class Elem> 
TabellaHash2<Elem>::TabellaHash2(int dim, HashFunctionBase *hashFun, ProbeFunctionBase *probeFun)
{
    this->dim = dim;
    dati = new HashElem<Elem>[dim];
    this->hashFun=hashFun;
    this->probeFun=probeFun;
}
template <class Elem> 
TabellaHash2<Elem>::~TabellaHash2()
{
    delete[] dati;
}
template <class Elem> 
bool             
TabellaHash2<Elem>::insert(Elem e, int key)
{
   int homePos = hashFun-> h(key);
   HashElem<Elem> he(e,key);
   for (int i=0; i<dim; i++)
   {
       int pos = homePos + probeFun-> p(key,i);
       if (dati[pos].isFree())
       {
           dati[pos]=he;
           return true;
       }
   }
   return false;
}
template <class Elem> 
bool             
TabellaHash2<Elem>::search(Elem &e, int key)
{
   int homePos = hashFun-> h(key);
   int pos = homePos;
   for (int i=0; i<dim && !dati[pos].getNil() ; i++)
   {
       int pos = homePos + probeFun-> p(key,i);
       if (dati[pos].getKey()==key)
       {
           e=dati[pos].getElem();
           return true;
       }
   }
   return false;
}

template <class Elem> 
bool                          
TabellaHash2<Elem>::del(int key)
{
   int homePos = hashFun-> h(key);
   int pos = homePos;
   for (int i=0; i<dim && !dati[pos].getNil() ; i++)
   {
       int pos = homePos + probeFun-> p(key,i);
       if (dati[pos].getKey()==key)
       {
           dati[pos].setTomb(true);
           return true;
       }
   }
   return false;
}
#endif
